# A class which has two channels, one for which a state is true
# and the other for when the state if false
class BoolChannel
  getter when_true = Channel(Nil).new
  getter when_false = Channel(Nil).new
  @value = Channel(Bool).new

  def initialize(value : Bool)
    spawn(name: "BoolChannel#send_loop") do
      send_loop(value)
    end
  end

  def set(value : Bool)
    @value.send value
  rescue Channel::ClosedError
    Log.debug { "BoolChannel closed, could not set value" }
  end

  def close
    @when_true.close
    @when_false.close
    @value.close
  end

  private def send_loop(value)
    loop do
      channel = value ? @when_true : @when_false
      select
      when channel.send nil
      when value = @value.receive
      end
    end
  rescue Channel::ClosedError
  end
end
